# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
"""new action for failed executions

Revision ID: 08b7460a5ced
Revises: 91f96bd53b5b
Create Date: 2021-10-25 10:04:18.574143

"""
from alembic import op

# revision identifiers, used by Alembic.
revision = "08b7460a5ced"
down_revision = "91f96bd53b5b"
branch_labels = None
depends_on = None


def upgrade():
    sql = """
    INSERT INTO capability_state_actions (transition_id, action_type, arguments)
    SELECT transition_id, 'SendMessage', 'execution_failed' as arguments
    FROM capability_state_transitions WHERE pattern = 'type == workflow-failed';

    INSERT INTO capability_state_actions (transition_id, action_type, arguments)
    SELECT transition_id, 'SendMessage', 'execution_complete' as arguments
    FROM capability_state_transitions WHERE pattern = 'type == workflow-complete';
    """
    op.execute(sql)


def downgrade():
    op.execute("DELETE FROM capability_state_actions WHERE action_type = 'SendMessage'")
